/* |C^ɂ`Xgi\[Xj */

#include <stdio.h>
#include <stdlib.h>
#include "Member.h"
#include "LinkedList.h"

/*--- ̃m[h𓮓Iɐ ---*/
static Node *AllocNode(void)
{
	return calloc(1, sizeof(Node));
}

/*--- n̎wm[h̊eoɒlݒ ----*/
static void SetNode(Node *n, const Member *x, const Node *next)
{
	n->data = *x;		/* f[^ */
	n->next = next;		/* 㑱|C^ */
}

/*--- `Xg ---*/
void Initialize(List *list)
{
	list->head = NULL;		/* 擪m[h */
	list->crnt = NULL;		/* ڃm[h */
}

/*--- ֐compareɂxƈvƔ肳m[hT ---*/
Node *Search(List *list, const Member *x,
	int compare(const Member *x, const Member *y))
{
	Node *ptr = list->head;

	while (ptr != NULL) {
		if (compare(&ptr->data, x) == 0) {	/* L[lv */
			list->crnt = ptr;
			return ptr;					/* T */
		}
		ptr = ptr->next;				/* 㑱m[hɒ */
	}
	return NULL;						/* Ts */
}

/*--- 擪Ƀm[h} ---*/
void InsertFront(List *list, const Member *x)
{
	Node *ptr = list->head;
	list->head = list->crnt = AllocNode();
	SetNode(list->head, x, ptr);
}

/*--- Ƀm[h} ---*/
void InsertRear(List *list, const Member *x)
{
	if (list->head == NULL)					/* ł */
		InsertFront(list, x);				/* 擪ɑ} */
	else {
		Node *ptr = list->head;
		while (ptr->next != NULL)
			ptr = ptr->next;
		ptr->next = list->crnt = AllocNode();
		SetNode(ptr->next, x, NULL);
	}
}

/*--- 擪m[h폜 ---*/
void RemoveFront(List *list)
{
	if (list->head != NULL) {
		Node *ptr = list->head->next;		/* QԖڂ̃m[hւ̃|C^ */
		free(list->head);					/* 擪m[h */
		list->head = list->crnt = ptr;		/* V擪m[h */
	}
}

/*--- m[h폜 ---*/
void RemoveRear(List *list)
{
	if (list->head != NULL) {
		if ((list->head)->next == NULL)		/* m[hł */
			RemoveFront(list);				/* 擪m[h폜 */
		else {
			Node *ptr = list->head;
			Node *pre;

			while (ptr->next != NULL) {
				pre = ptr;
				ptr = ptr->next;
			}
			pre->next = NULL;				/* pre͖2Ԗ */
			free(ptr);						/* ptr͖ */
			list->crnt = pre;
		}
	}
}

/*--- ڃm[h폜 ---*/
void RemoveCurrent(List *list)
{
	if (list->head != NULL) {
		if (list->crnt == list->head)	/* 擪m[hɒڂĂ */
			RemoveFront(list);			/* 擪m[h폜 */
		else {
			Node *ptr = list->head;

			while (ptr->next != list->crnt)
				ptr = ptr->next;
			ptr->next = list->crnt->next;
			free(list->crnt);
			list->crnt = ptr;
		}
	}
}

/*--- Sm[h폜 ---*/
void Clear(List *list)
{
	while (list->head != NULL)			/* ɂȂ܂ */
		RemoveFront(list);				/* 擪m[h폜 */
	list->crnt = NULL;
}

/*--- ڃm[h̃f[^\ ---*/
void PrintCurrent(const List *list)
{
	if (list->crnt == NULL)
		printf("ڃm[h͂܂B");
	else
		PrintMember(&list->crnt->data);
}

/*--- ڃm[h̃f[^\istj---*/
void PrintLnCurrent(const List *list)
{
	PrintCurrent(list);
	putchar('\n');
}

/*--- Sm[h̃f[^Xgɕ\ ---*/
void Print(const List *list)
{
	if (list->head == NULL)
		puts("m[h܂B");
	else {
		Node *ptr = list->head;

		puts("yꗗ\z");
		while (ptr != NULL) {
			PrintLnMember(&ptr->data);
			ptr = ptr->next;				/* 㑱m[hɒ */
		}
	}
}

/*--- `Xǧn ---*/
void Terminate(List *list)
{
	Clear(list);						/* Sm[h폜 */
}
